package
 {
  import flash.display.Sprite;
  import flash.display.SimpleButton;
  import flash.text.TextField;
  
  
  import flash.text.StyleSheet;



  public class AR_Button extends Sprite
   {
	private var skin          : XML;
	private var label         : String;
	private var icon          : String;
	private var button_width  : int;
	private var button_height : int;

	protected var desktop : AR_Desktop;

    public function AR_Button(dsk : AR_Desktop, skn : XML, lab : String, ico : String, w : int, h : int)
     {
      var button : SimpleButton = new SimpleButton();

      desktop = dsk;
      skin    = skn;
      label   = lab;
      icon    = ico;
      button_width  = w;
      button_height = h;
      button.upState       = makeUpState();
      button.overState     = makeOverState();
      button.downState     = makeDownState();
	  button.hitTestState  = makeHitTestState();
      button.useHandCursor = true;
      addChild(button);
     }

    private function makeUpState() : Sprite
     {
	  var label : TextField = new TextField();
	  var image : AR_Image  = new AR_Image(desktop.getSkinPath()+skin.button_up,button_width,button_height);
	  var icon  : AR_Image;
      var state : Sprite    = new Sprite();
      var align : String;

      align = skin.button_text_align;
      label.htmlText   = this.label;
	  if(skin.button_text_bold      == "1") label.htmlText = "<b>"+label.htmlText+"</b>";
	  if(skin.button_text_italic    == "1") label.htmlText = "<i>"+label.htmlText+"</i>";
	  if(skin.button_text_underline == "1") label.htmlText = "<u>"+label.htmlText+"</u>";
	  label.textColor  = skin.button_text_color;
      label.selectable = false;
      label.width      = label.textWidth  + 4;
	  label.height     = label.textHeight + 4;
	  label.x = 0;
	  if(align == "center") label.x = (button_width  - label.width)  / 2;
	  if(align == "right")  label.x = button_width - label.width;
      label.y = (button_height - label.height) / 2;
	  state.addChild(image);
	  if(this.icon != "")
	   {
		icon = new AR_Image(desktop.getSkinPath()+this.icon,button_width,button_height);
	    state.addChild(icon);
	   }
	  state.addChild(label);
	  return state;
     }

    private function makeOverState() : Sprite
     {
	  var label : TextField = new TextField();
	  var image : AR_Image  = new AR_Image(desktop.getSkinPath()+skin.button_over,button_width,button_height);
	  var icon  : AR_Image;
      var state : Sprite    = new Sprite();
      var align : String;

      align = skin.button_text_align;
	  label.htmlText   = this.label;
	  if(skin.button_text_bold      == "1") label.htmlText = "<b>"+label.htmlText+"</b>";
	  if(skin.button_text_italic    == "1") label.htmlText = "<i>"+label.htmlText+"</i>";
	  if(skin.button_text_underline == "1") label.htmlText = "<u>"+label.htmlText+"</u>";
	  label.textColor  = skin.button_text_color;
      label.selectable = false;
      label.width      = label.textWidth  + 4;
	  label.height     = label.textHeight + 4;
	  label.x = 0;
	  if(align == "center") label.x = (button_width  - label.width)  / 2;
	  if(align == "right")  label.x = button_width - label.width;
      label.y = (button_height - label.height) / 2;
	  state.addChild(image);
	  state.addChild(label);
	  if(this.icon != "")
	   {
		icon = new AR_Image(desktop.getSkinPath()+this.icon,button_width,button_height);
	    state.addChild(icon);
	   }
	  return state;
     }

    private function makeDownState() : Sprite
     {
	  var label : TextField = new TextField();
	  var image : AR_Image  = new AR_Image(desktop.getSkinPath()+skin.button_over,button_width,button_height);
	  var icon  : AR_Image;
      var state : Sprite    = new Sprite();
      var align : String;

      align = skin.button_text_align;
	  label.htmlText   = this.label;
	  if(skin.button_text_bold      == "1") label.htmlText = "<b>"+label.htmlText+"</b>";
	  if(skin.button_text_italic    == "1") label.htmlText = "<i>"+label.htmlText+"</i>";
	  if(skin.button_text_underline == "1") label.htmlText = "<u>"+label.htmlText+"</u>";
	  label.textColor  = skin.button_text_color;
      label.selectable = false;
      label.width      = label.textWidth  + 4;
	  label.height     = label.textHeight + 4;
	  label.x = 0;
	  if(align == "center") label.x = (button_width  - label.width)  / 2;
	  if(align == "right")  label.x = button_width - label.width;
      label.y = (button_height - label.height) / 2;
      label.y += 2;
	  state.addChild(image);
	  state.addChild(label);
	  if(this.icon != "")
	   {
		icon = new AR_Image(desktop.getSkinPath()+this.icon,button_width,button_height);
		icon.y += 2;
	    state.addChild(icon);
	   }
      return state;
     }

    private function makeHitTestState() : Sprite
     {//TODO...
      var state : Sprite = new Sprite();

      state.graphics.beginFill(0x000000);
      state.graphics.drawRect(0,0,button_width,button_height);
	  state.graphics.endFill();
	  return state;
     }
   }
 }
