package
 {
  import flash.display.Sprite;
  import flash.text.TextField;
  import flash.events.Event;
  import flash.events.MouseEvent;
  import flash.text.StyleSheet;

  public class AR_Desktop extends Sprite
   {
	public  var background : AR_Image;
	public  var logo       : AR_Image;
	public  var title      : TextField;
	public  var page_title : TextField;
    public  var content    : TextField;

    public  var image     : AR_winImage;
    public  var thumbs    : AR_winImagesList;
    public  var sub_menu  : AR_winSubMenu;
	private var main_menu : AR_winMainMenu;
    private var css       : StyleSheet;
	private var xml_file  : AR_XML;
	private var config    : XML;
	private var skin      : XML;
	private var data      : XML;

    public function AR_Desktop()
     {	  
      /*
	  xml_file = new AR_XML("Albume.xml");//TODO verificare se si può caricare un file non da url (cioè da filesystem)
	  var t : TextField = new TextField();
	  t.text        = "xxx";//xml_file.xml.toString();
      t.width       = 540;
	  t.height      = 20;
	  addChild(t);*/

	  if(!xml_file) xml_file = new AR_XML("index.php?action=1");
      xml_file.loader.addEventListener(Event.COMPLETE, exec);
     }

    public function exec(event : Event) : void
	 {
      // Load xml file
      xml_file.xml = XML(event.target.data);
      config = new XML(xml_file.xml.config);
      skin   = new XML(xml_file.xml.skin);
      data   = new XML(xml_file.xml.data);

      // Load css file
	  css = new StyleSheet();
      css.parseCSS(skin.css);

      // Create desktop
      makeDesktop();
	 }

	private function makeDesktop() : void
	 {
	  // Background
      //graphics.lineStyle(1,0x000000);
	  graphics.beginFill(skin.desktop.bgcolor);
	  graphics.drawRect(0,0,config.width,config.height);
	  graphics.endFill();
	  if(skin.desktop_background)
	   {
	    background = new AR_Image(getSkinPath()+skin.desktop.background,config.width,config.height);
	    background.alpha = skin.desktop.bgalpha;
	    addChild(background);
	   }

	  // Logo
	  logo   = new AR_Image(getLogoPath()+config.logo,0,0,false);
	  logo.x = skin.desktop.logo_x;
	  logo.y = skin.desktop.logo_y;
	  addChild(logo);
	  
	  // Site title
	  title            = new TextField();
	  title.styleSheet = css;
	  title.text       = "";
	  title.htmlText   = "<span class='title'>"+config.title.text()+"</span>";
	  title.selectable = false;
      title.width      = 800;
	  title.height     = 50;
	  title.x          = skin.desktop.title_x;
	  title.y          = skin.desktop.title_y;
	  addChild(title);
	  
	  // Page title
	  page_title            = new TextField();
	  page_title.styleSheet = css;
	  page_title.text       = "";
	  page_title.selectable = false;
      page_title.width      = 800;
	  page_title.height     = 50;
	  page_title.x          = skin.desktop.page_title_x;
	  page_title.y          = skin.desktop.page_title_y;
	  addChild(page_title);
	  
	  // Page content
	  content            = new TextField();
	  content.styleSheet = css;
	  content.text       = "";
	  content.htmlText   = "";
	  content.selectable = false;
      content.width      = 800;
	  content.height     = 560;// meno posizione y
	  content.x          = skin.desktop.content_x;
	  content.y          = skin.desktop.content_y;
	  addChild(content);
	  if(data.page.length()) // Starting page (if exists at least one page)
	   {
	    page_title.htmlText = "<span class='pageTitle'>"+data.page[0].title+"</span>";
	    content.htmlText    = data.page[0].content;
	   }

      // Page foot
      var foot : TextField = new TextField();
      foot.htmlText = "<a href=\"http://www.valarsoft.com\" target=\"_blank\">Powered by: AlbumE 0.2</a>";
      content.selectable = false;
      foot.width = 135;
      foot.height = 20;
      foot.x = config.width - foot.width;
      foot.y = config.height - foot.height;
      addChild(foot);
      
      // Images window
	  image = new AR_winImage(this,new XML(skin.image),"",640,480);
	  image.x = 5;
	  image.y = 56;
	  //addChild(image); // Show on startup

      // Thumbnails window
	  thumbs = new AR_winImagesList(this,new XML(skin.thumbnails),"",image,128,440);
	  thumbs.x = 660;
	  thumbs.y = 80;
	  //addChild(thumbs); // Show on startup

      // Sub menu
	  sub_menu = new AR_winSubMenu(this,new XML(skin.sub_menu),data,"",thumbs);
	  sub_menu.x = 200;
	  sub_menu.y = 40;
	  //sub_menu.makeButtons(new XML(data.category[0])); // Default album
	  //addChild(sub_menu); // Show on startup

      // Main menu
	  main_menu = new AR_winMainMenu(this,new XML(skin.main_menu),data,"");
	  main_menu.x = skin.desktop.main_menu_x;
	  main_menu.y = skin.desktop.main_menu_y;
	  main_menu.makeButtons(sub_menu,data);
	  addChild(main_menu);
	 }

	public function getSkinPath() : String
	 {
	  return config.skin_path.text()+config.skin.text()+"/";
	 }

	public function getLogoPath() : String
	 {
	  return config.logo_path.text();
	 }

   }
 }
