package
 {
  import flash.display.Sprite;
  import flash.text.TextField;
  import flash.events.MouseEvent;

  public class AR_Window extends Sprite
   {
	protected var skin  : XML;
	protected var title : TextField;

	private var head        : Sprite;
	private var head_margin : int;
	private var head_width  : int;
	private var head_height : int;

	protected var desktop     : AR_Desktop;
	protected var body        : Sprite;
	protected var body_margin : int;
	protected var body_width  : int;
	protected var body_height : int;

    public function AR_Window(d : AR_Desktop, s : XML, t : String, w : int, h : int, no_head : Boolean = false)
     {
	  title      = new TextField();
      desktop    = d;
	  skin       = s;
	  title.text = t;

      // Window head
      if(!no_head)
       {
        head = makeHead();
	    head.addEventListener(MouseEvent.MOUSE_DOWN,take);
	    head.addEventListener(MouseEvent.MOUSE_UP,  release);
	    addChild(head);
	   }

      // Window body
      body_width  = w;
      body_height = h;
      body = makeBody();
      addChild(body);
	  
	  // Windows bottom
	  //TODO
     }

    private function makeHead() : Sprite
     {
	  head_width  = 110;
	  head_height = 20;
	  head_margin = 2;

	  var image : AR_Image  = new AR_Image(desktop.getSkinPath()+skin.window_head,head_width,head_height);
      var head  : Sprite    = new Sprite();

      title.selectable = false;
      title.width      = width - head_width;
	  title.height     = head_height;
	  head.addChild(image);
	  head.addChild(title);
	  return head;
     }

    protected function makeBody() : Sprite
     {
	  body_margin = 5;

	  var image : AR_Image = new AR_Image(desktop.getSkinPath()+skin.window_body,body_width,body_height);
      var body  : Sprite   = new Sprite();

	  body.addChild(image);
	  body.y = head_height;
	  return body;
	 }

    private function take(event : MouseEvent) : void
     {
      alpha = 0.75;
	  parent.setChildIndex(this,parent.numChildren - 1);
	  startDrag();
     }

    private function release(event : MouseEvent) : void
     {
      alpha = 1;
	  stopDrag();
     }

    public function getDesktop() : AR_Desktop
     {
	  return desktop;
	 }

    public function setTitle(t : String) : void
     {
      title.text = t;
     }
   }
 }
