package
 {
  public class AR_winSubMenu extends AR_Window
   {
	private var _BUTTONS      : Array = new Array();
    private var thumbs        : AR_winImagesList;

	private var button_width  : int;
	private var button_height : int;
	private var h_margin      : int;
	private var v_margin      : int;
	private var spacing       : int;
	private var layout        : int;

    public function AR_winSubMenu(dsk : AR_Desktop, skn : XML, dat : XML, tit : String, thu : AR_winImagesList)
     {
      button_width  = skn.button_width;
      button_height = skn.button_height;
      h_margin      = skn.window_h_margin;
      v_margin      = skn.window_v_margin;
      spacing       = skn.button_spacing;
      if(skn.window_layout == "horizontal") layout = 1;
      else                                  layout = 0;

      super(dsk,skn,tit,0,0,true);
      thumbs = thu;
     }

    public function makeButtons(data : XML) : void
     {
      var n : int;

      n = data.album.length();
      if(layout) // Horizontal layout
       {
	    body_width  = (button_width + spacing) * n + h_margin * 2;
	    body_height = button_height + v_margin * 2;
	   }
	  else
	   {
		body_width = button_width + h_margin * 2;
	    body_height = (button_height + spacing) * n + v_margin * 2;
	   }
      removeChild(body);
      body = makeBody();
      addChild(body);

      for(var i : int = 0; i < data.album.length(); i++)
       {
        var b : AR_btnAlbum = new AR_btnAlbum(desktop,skin,data.album[i].title,"",button_width,button_height);
	    b.setThumbs(thumbs);
	    b.setDataArray(new XML(data.album[i]));
	    addButton(b);   
       }
	 }

    public function addButton(b : AR_Button) : void
     {
      var l : int = _BUTTONS.push(b);
      body.addChild(_BUTTONS[l-1]);
      if(layout) // Horizontal layout
       {
        _BUTTONS[l-1].x = (button_width + spacing) * (l-1) + h_margin;
        _BUTTONS[l-1].y = v_margin;
       }
      else
       {
        _BUTTONS[l-1].x = h_margin;
        _BUTTONS[l-1].y = (button_height + spacing) * (l-1) + v_margin;
	   }
	 }

    public function clearMenu() : void
	 {
      var i : int;
      var l : int = _BUTTONS.length;
      for(i = 0; i < l; i++)
       {
	    body.removeChild(_BUTTONS[i]);
       }
      _BUTTONS = new Array();
	 }
   }
 }
